VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIPortableDevice"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

' veraltet
 Private Const CLSID_PortableDevice As String = _
    "{728A21C5-3D9E-48D7-9810-864848F0F404}"

'Private Const CLSID_PortableDeviceFTM As String = _
    "{F7C0039A-4762-488A-B4B3-760EF9A1BA9B}"

Private Const IID_IPortableDevice As String = _
    "{625E2DF8-6392-4CF0-9AD1-3CFA5F17775C}"

Private Const ERR_BASE As Long = 40670

Private m_initialized As Boolean
Private m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_Open
    vtb_SendCommand
    vtb_Content
    vtb_Capabilities
    vtb_Cancel
    vtb_Close
    vtb_Advise
    vtb_Unadvise
    vtb_GetPnPDeviceID
End Enum

Public Function GetInterfacePtr() As Long

    GetInterfacePtr = m_Interface.ifc

End Function

Public Function OpenDevice(ByVal PnPDeviceID As String, ByRef cDeviceValues As _
    clsIPortableDeviceValues) As Boolean

    Dim bRet As Boolean
    Dim pszPnPDeviceID As Long
    Dim pDeviceValues As Long

    bRet = False
    pszPnPDeviceID = StrPtr(PnPDeviceID)
    pDeviceValues = ObjPtr(cDeviceValues)

    If x_OleInvoke(vtb_Open, pszPnPDeviceID, cDeviceValues.GetInterfacePtr) Then

        bRet = True

    End If

    OpenDevice = bRet

End Function

Public Function SendCommand(ByVal Parameters As clsIPortableDeviceValues) As clsIPortableDeviceValues

    Dim pResults As Long
    Dim ppResults As Long
    Dim IPortableDeviceValues As clsIPortableDeviceValues
    
    ppResults = VarPtr(pResults)

    If x_OleInvoke(vtb_SendCommand, 0&, Parameters.GetInterfacePtr, ppResults) Then

        Set IPortableDeviceValues = New clsIPortableDeviceValues
        Call IPortableDeviceValues.Initialize(pResults)
        
    End If

    Set SendCommand = IPortableDeviceValues

End Function

Public Function Content() As clsIPortableDeviceContent

    Dim pContent As Long ' IPortableDeviceContent
    Dim ppContent As Long
    Dim IPortableDeviceContent As clsIPortableDeviceContent
    
    ppContent = VarPtr(pContent)

    If x_OleInvoke(vtb_Content, ppContent) Then

        Set IPortableDeviceContent = New clsIPortableDeviceContent
        Call IPortableDeviceContent.Initialize(pContent)
        
    End If

    Set Content = IPortableDeviceContent

End Function

Public Function Capabilities() As clsIPortableDeviceCapabilities
    
    Dim pCapabilities As Long ' IPortableDeviceCapabilities
    Dim ppCapabilities As Long
    Dim IPortableDeviceCapabilities As clsIPortableDeviceCapabilities

    ppCapabilities = VarPtr(pCapabilities)

    If x_OleInvoke(vtb_Capabilities, ppCapabilities) Then

        Set IPortableDeviceCapabilities = New clsIPortableDeviceCapabilities
        Call IPortableDeviceCapabilities.Initialize(pCapabilities)
        
    End If

    Set Capabilities = IPortableDeviceCapabilities

End Function

Public Function Cancel() As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_Cancel) Then

        bRet = True

    End If

    Cancel = bRet

End Function

Public Function CloseDevice() As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_Close) Then

        bRet = True

    End If

    CloseDevice = bRet

End Function

Public Function Advise(ByVal dwFlags As Long, ByRef cCallback As _
    clsIPortableDeviceEventCallback) As Boolean

    Dim bRet As Boolean
    Dim pdwFlags As Long
    Dim pszCookie As Long

    bRet = False
    pdwFlags = VarPtr(dwFlags)
    ppszCookie = VarPtr(pszCookie)

    If x_OleInvoke(vtb_Advise, pdwFlags, cCallback.GetInterfacePtr, 0&, ppszCookie) Then

        bRet = True

    End If

    Advise = bRet

End Function

Public Function Unadvise(ByVal szCookie As String) As Boolean

    Dim bRet As Boolean
    Dim pszCookie As Long

    bRet = False
    pszCookie = StrPtr(szCookie)

    If x_OleInvoke(vtb_Unadvise, pszCookie) Then

        bRet = True

    End If

    Unadvise = bRet

End Function

Public Function GetPnPDeviceID() As String

    Dim sRet As String
    Dim pszPnPDeviceID As Long
    Dim ppszPnPDeviceID As Long

    sRet = vbNullString
    ppszPnPDeviceID = VarPtr(pszPnPDeviceID)

    If x_OleInvoke(vtb_GetPnPDeviceID, ppszPnPDeviceID) Then

        sRet = GetStringFromPointer(pszPnPDeviceID)

    End If

    GetPnPDeviceID = sRet

End Function

Public Sub Initialize(Optional ByVal pInterface As Long = 0)
    
    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    If pInterface = 0 Then

        m_initialized = InitInterface(m_Interface, CLSID_PortableDevice, _
            IID_IPortableDevice)
    
    Else
        
        m_Interface.ifc = pInterface
        m_initialized = True
    
    End If
End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface

End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As Boolean

    Dim ret As Long

    If Not m_initialized Then

        InterfaceError m_Interface, ecd_OleInvoke

    Else

        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)

    End If

End Function

Private Sub x_RaiseError()

    With m_Interface

        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIPortableDevice", .etx

        .ecd = 0
        .etx = ""

    End With

End Sub



