VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIPortableDeviceManager"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Const CLSID_PortableDeviceManager As String = _
    "{0AF10CEC-2ECD-4B92-9581-34F6AE0637F3}"

Private Const IID_IPortableDeviceManager As String = _
    "{A1567595-4C2F-4574-A6FA-ECEF917B9A40}"

Private Const ERR_BASE As Long = 40670

Private m_initialized As Boolean
Private m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_GetDevices
    vtb_RefreshDeviceList
    vtb_GetDeviceFriendlyName
    vtb_GetDeviceDescription
    vtb_GetDeviceManufacturer
    vtb_GetDeviceProperty
    vtb_GetPrivateDevices
End Enum

Public Function GetInterfacePtr() As Long

    GetInterfacePtr = m_Interface.ifc

End Function

Public Function GetDevices(ByRef cPnPDeviceIDs As Long, ByRef PnPDeviceIDs() As _
    Long) As Boolean

    Dim bRet As Boolean
    Dim pPnPDeviceIDs As Long
    Dim pcPnPDeviceIDs As Long

    bRet = False
    pcPnPDeviceIDs = VarPtr(cPnPDeviceIDs)

    ' 1. Aufruf: Gre des Buffer ermitteln -> cPnPDeviceIDs
    If x_OleInvoke(vtb_GetDevices, 0&, pcPnPDeviceIDs) Then

        If cPnPDeviceIDs > 0 Then

            ' Buffer dimensionieren
            ReDim PnPDeviceIDs(cPnPDeviceIDs - 1)
            pPnPDeviceIDs = VarPtr(PnPDeviceIDs(0))

            ' 2. Aufruf: Buffer fllen
            If x_OleInvoke(vtb_GetDevices, pPnPDeviceIDs, pcPnPDeviceIDs) Then

                bRet = True

            End If
        End If
    End If

    GetDevices = bRet

End Function

Public Function RefreshDeviceList() As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_RefreshDeviceList) Then

        bRet = True

    End If

    RefreshDeviceList = bRet

End Function

Public Function GetDeviceFriendlyName(ByVal PnPDeviceID As String) As String

    Dim sRet As String
    Dim pszPnPDeviceID As Long
    Dim pDeviceFriendlyName As Long
    Dim pcchDeviceFriendlyName As Long
    Dim sDeviceFriendlyName As String
    Dim lcchDeviceFriendlyName As Long

    sRet = vbNullString
    pszPnPDeviceID = StrPtr(PnPDeviceID)
    pcchDeviceFriendlyName = VarPtr(lcchDeviceFriendlyName)

    ' 1. Aufruf: Gre des Buffer ermitteln -> lcchDeviceFriendlyName
    If x_OleInvoke(vtb_GetDeviceFriendlyName, pszPnPDeviceID, 0&, _
        pcchDeviceFriendlyName) Then

        If lcchDeviceFriendlyName > 0 Then

            ' Buffer dimensionieren
            sDeviceFriendlyName = String$(lcchDeviceFriendlyName, vbNullChar)
            pDeviceFriendlyName = StrPtr(sDeviceFriendlyName)

            ' 2. Aufruf: Buffer fllen
            If x_OleInvoke(vtb_GetDeviceFriendlyName, pszPnPDeviceID, _
                pDeviceFriendlyName, pcchDeviceFriendlyName) Then

                sRet = Left$(sDeviceFriendlyName, lcchDeviceFriendlyName - 1)

            End If
        End If
    End If

    GetDeviceFriendlyName = sRet

End Function

Public Function GetDeviceDescription(ByVal PnPDeviceID As String) As String

    Dim sRet As String
    Dim pszPnPDeviceID As Long
    Dim pDeviceDescription As Long
    Dim pcchDeviceDescription As Long
    Dim sDeviceDescription As String
    Dim lcchDeviceDescription As Long

    sRet = vbNullString
    pszPnPDeviceID = StrPtr(PnPDeviceID)
    pcchDeviceDescription = VarPtr(lcchDeviceDescription)

    ' 1. Aufruf: Gre des Buffer ermitteln -> lcchDeviceDescription
    If x_OleInvoke(vtb_GetDeviceDescription, pszPnPDeviceID, 0&, _
        pcchDeviceDescription) Then

        If lcchDeviceDescription > 0 Then

            ' Buffer dimensionieren
            sDeviceDescription = String$(lcchDeviceDescription, vbNullChar)
            pDeviceDescription = StrPtr(sDeviceDescription)

            ' 2. Aufruf: Buffer fllen
            If x_OleInvoke(vtb_GetDeviceDescription, pszPnPDeviceID, _
                pDeviceDescription, pcchDeviceDescription) Then

                sRet = Left$(sDeviceDescription, lcchDeviceDescription - 1)

            End If
        End If
    End If

    GetDeviceDescription = sRet

End Function

Public Function GetDeviceManufacturer(ByVal PnPDeviceID As String) As String

    Dim sRet As String
    Dim pszPnPDeviceID As Long
    Dim pDeviceManufacturer As Long
    Dim pcchDeviceManufacturer As Long
    Dim sDeviceManufacturer As String
    Dim lcchDeviceManufacturer As Long

    sRet = vbNullString
    pszPnPDeviceID = StrPtr(PnPDeviceID)
    pcchDeviceManufacturer = VarPtr(lcchDeviceManufacturer)

    ' 1. Aufruf: Gre des Buffer ermitteln -> lcchDeviceManufacturer
    If x_OleInvoke(vtb_GetDeviceManufacturer, pszPnPDeviceID, 0&, _
        pcchDeviceManufacturer) Then

        If lcchDeviceManufacturer > 0 Then

            ' Buffer dimensionieren
            sDeviceManufacturer = String$(lcchDeviceManufacturer, vbNullChar)
            pDeviceManufacturer = StrPtr(sDeviceManufacturer)

            ' 2. Aufruf: Buffer fllen
            If x_OleInvoke(vtb_GetDeviceManufacturer, pszPnPDeviceID, _
                pDeviceManufacturer, pcchDeviceManufacturer) Then

                sRet = Left$(sDeviceManufacturer, lcchDeviceManufacturer - 1)

            End If
        End If
    End If

    GetDeviceManufacturer = sRet

End Function

Public Function GetDeviceProperty(ByVal PnPDeviceID As String, ByVal _
    DevicePropertyName As String) As String

    Dim sRet As String
    Dim pszPnPDeviceID As Long
    Dim pszDevicePropertyName As Long
    Dim pData As Long
    Dim pcbData As Long
    Dim pdwType As Long
    Dim Data() As Byte
    Dim cbData As Long
    Dim dwType As Long

    sRet = vbNullString

    pszPnPDeviceID = StrPtr(PnPDeviceID)
    pszDevicePropertyName = StrPtr(DevicePropertyName)
    pcbData = VarPtr(cbData)
    pdwType = VarPtr(dwType)

    ' 1. Aufruf: Gre des Buffer ermitteln -> cbData
    If x_OleInvoke(vtb_GetDeviceProperty, pszPnPDeviceID, pszDevicePropertyName, _
        0&, pcbData, pdwType) Then

        If cbData > 0 Then

            ' Buffer dimensionieren
            ReDim Data(cbData)
            pData = VarPtr(Data(0))

            ' 2. Aufruf: Buffer fllen
            If x_OleInvoke(vtb_GetDeviceProperty, pszPnPDeviceID, _
                pszDevicePropertyName, pData, pcbData, pdwType) Then

                Select Case dwType
                Case REG_NONE
                Case REG_SZ
                    sRet = Data

                Case Else
                    sRet = Data

                End Select

            End If
        End If
    End If

    GetDeviceProperty = sRet

End Function

Public Function GetPrivateDevices(ByRef cPnPDeviceIDs As Long, ByRef PnPDeviceIDs( _
    ) As Long) As Boolean

    Dim bRet As Boolean
    Dim pPnPDeviceIDs As Long
    Dim pcPnPDeviceIDs As Long

    bRet = False
    pcPnPDeviceIDs = VarPtr(cPnPDeviceIDs)

    ' 1. Aufruf: Gre des Buffer ermitteln -> cPnPDeviceIDs
    If x_OleInvoke(vtb_GetPrivateDevices, 0&, pcPnPDeviceIDs) Then

        If cPnPDeviceIDs > 0 Then

            ' Buffer dimensionieren
            ReDim PnPDeviceIDs(cPnPDeviceIDs)
            pPnPDeviceIDs = VarPtr(PnPDeviceIDs(0))

            ' 2. Aufruf: Buffer fllen
            If x_OleInvoke(vtb_GetPrivateDevices, pPnPDeviceIDs, pcPnPDeviceIDs) _
                Then

                bRet = True

            End If
        End If
    End If

    GetPrivateDevices = bRet

End Function

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    If pInterface = 0 Then

        m_initialized = InitInterface(m_Interface, CLSID_PortableDeviceManager, _
            IID_IPortableDeviceManager)
    
    Else
        
        m_Interface.ifc = pInterface
        m_initialized = True
    
    End If
    
End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface

End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As Boolean

    Dim ret As Long

    If Not m_initialized Then

        InterfaceError m_Interface, ecd_OleInvoke

    Else

        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)

    End If

End Function

Private Sub x_RaiseError()

    With m_Interface

        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIPortableDeviceManager", .etx

        .ecd = 0
        .etx = ""

    End With

End Sub

