VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIPortableDevicePropVariantCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const CLSID_PortableDevicePropVariantCollection As String = _
    "{08A99E2F-6D6D-4B80-AF5A-BAF2BCBE4CB9}"

Private Const IID_IPortableDevicePropVariantCollection As String = _
    "{89B2E422-4F1B-4316-BCEF-A44AFEA83EB3}"

Private Const ERR_BASE As Long = 40670

Private m_initialized As Boolean
Private m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_GetCount
    vtb_GetAt
    vtb_Add
    vtb_GetType
    vtb_ChangeType
    vtb_Clear
    vtb_RemoveAt
End Enum

Public Function GetInterfacePtr() As Long

    GetInterfacePtr = m_Interface.ifc

End Function

Public Function GetCount() As Long

    Dim lRet As Long
    Dim pcElems As Long
    Dim ppcElems As Long
    
    ppcElems = VarPtr(pcElems)
    
    If x_OleInvoke(vtb_GetCount, ppcElems) Then

        lRet = pcElems

    End If

    GetCount = lRet

End Function

Friend Function GetAt(ByVal dwIndex As Long) As PropVariant

    Dim tPropVariant As PropVariant
    Dim pValue As Long
    Dim ppValue As Long
    
    pValue = VarPtr(tPropVariant)
    ppValue = VarPtr(pValue)
    
    If x_OleInvoke(vtb_GetAt, dwIndex, ppValue) Then
        

        Call CopyMemory(tPropVariant, pValue, LenB(tPropVariant))

    End If

    GetAt = tPropVariant

End Function

Friend Function Add(ByRef Value As PropVariant) As Boolean

    Dim bRet As Boolean
    Dim pValue As Long
    
    bRet = False
    pValue = VarPtr(Value)
    
    If x_OleInvoke(vtb_Add, pValue) Then

        bRet = True

    End If

    Add = bRet

End Function

Public Function GetType() As Long

    Dim vRet As Long
    Dim pvt As Long
    Dim ppvt As Long
    
    ppvt = VarPtr(pvt)
    
    If x_OleInvoke(vtb_GetType, ppvt) Then

        vRet = pvt

    End If

    GetType = vRet

End Function

'Public Function ChangeType() As Variant
'
'    Dim vRet As Variant
'    Dim pvt As Variant
'    Dim ppvt As Long
'
'    ppvt = VarPtr(pvt)
'
'    If x_OleInvoke(vtb_Change, ppvt) Then
'
'        vRet = pvt
'
'    End If
'
'    ChangeType = vRet
'
'End Function

Public Function Clear() As Boolean

    Dim bRet As Boolean
    
    bRet = False
    
    If x_OleInvoke(vtb_Clear) Then

        bRet = True

    End If

    Clear = bRet

End Function

Public Function RemoveAt(ByVal dwIndex As Long) As Boolean

    Dim bRet As Boolean
    
    bRet = False
    
    If x_OleInvoke(vtb_RemoveAt, dwIndex) Then

        bRet = True

    End If

    RemoveAt = bRet

End Function

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    If pInterface = 0 Then

        m_initialized = InitInterface(m_Interface, CLSID_PortableDevicePropVariantCollection, _
            IID_IPortableDevicePropVariantCollection)
    
    Else
        
        m_Interface.ifc = pInterface
        m_initialized = True
    
    End If
End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface

End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As Boolean

    Dim ret As Long

    If Not m_initialized Then

        InterfaceError m_Interface, ecd_OleInvoke

    Else

        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)

    End If

End Function

Private Sub x_RaiseError()

    With m_Interface

        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIPortableDevicePropVariantCollection", .etx

        .ecd = 0
        .etx = ""

    End With

End Sub



