VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIPortableDeviceResources"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Const CLSID_PortableDeviceResources As String = ""

Private Const IID_IPortableDeviceResources As String = _
    "{FD8878AC-D841-4D17-891C-E6829CDB6934}"

Private Const ERR_BASE As Long = 40670

Private m_initialized As Boolean
Private m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_GetSupportedResources
    vtb_GetResourceAttributes
    vtb_GetStream
    vtb_Delete
    vtb_Cancel
    vtb_CreateResource
End Enum

Public Function GetInterfacePtr() As Long

    GetInterfacePtr = m_Interface.ifc

End Function

Public Function GetSupportedResources(ByVal szObjectID As String) As clsIPortableDeviceKeyCollection

    Dim pszObjectID As Long
    Dim pKeys As Long
    Dim ppKeys As Long
    Dim IPortableDeviceKeyCollection As clsIPortableDeviceKeyCollection
    
    pszObjectID = StrPtr(szObjectID)
    ppKeys = VarPtr(pKeys)
    
    If x_OleInvoke(vtb_GetSupportedResources, pszObjectID, ppKey) Then
        
        Set IPortableDeviceKeyCollection = New clsIPortableDeviceKeyCollection
        Call IPortableDeviceKeyCollection.Initialize(pKey)
        
    End If

    Set GetSupportedResources = IPortableDeviceKeyCollection

End Function

Friend Function GetResourceAttributes(ByVal szObjectID As String, ByRef Key As PropertyKey) As clsIPortableDeviceKeyCollection

    Dim pszObjectID As Long
    Dim pKey As Long
    Dim pResourceAttributes As Long
    Dim ppResourceAttributes As Long
    Dim IPortableDeviceValues As clsIPortableDeviceValues
    
    pszObjectID = StrPtr(szObjectID)
    pKey = VarPtr(Key)
    ppResourceAttributes = VarPtr(pResourceAttributes)
    
    If x_OleInvoke(vtb_GetResourceAttributes, pszObjectID, pKey, ppResourceAttributes) Then
        
        Set IPortableDeviceValues = New clsIIPortableDeviceValues
        Call IPortableDeviceValues.Initialize(pResourceAttributes)
        
    End If

    Set GetResourceAttributes = IPortableDeviceValues

End Function

Friend Function GetStream(ByVal szObjectID As String, ByRef Key As PropertyKey, ByVal dwMode As STGM, ByRef dwOptimalBufferSize As Long) As clsIStream
    
    Dim pszObjectID As Long
    Dim pKey As Long
    Dim pdwOptimalBufferSize As Long
    Dim pStream As Long
    Dim ppStream As Long
    Dim IStream As clsIStream
    
    pszObjectID = StrPtr(szObjectID)
    pKey = VarPtr(Key)
    pdwOptimalBufferSize = VarPtr(dwOptimalBufferSize)
    ppStream = VarPtr(pStream)
    
    If x_OleInvoke(vtb_GetStream, pszObjectID, pKey, dwMode, pdwOptimalBufferSize, ppStream) Then
        
        Set IStream = New clsIStream
        Call IStream.Initialize(pStream)
        
    End If

    Set GetStream = IStream
    
End Function

Public Function Delete(ByVal szObjectID As String, ByVal pKeys As clsIPortableDeviceKeyCollection) As Boolean

    Dim bRet As Boolean
    Dim pszObjectID As Long
    
    bRet = False
    pszObjectID = StrPtr(szObjectID)
    
    If x_OleInvoke(vtb_Delete, pszObjectID, pKeys.GetInterfacePtr) Then
        
        bRet = True
        
    End If

    Delete = bRet

End Function

Public Function Cancel() As Boolean
    
    Dim bRet As Boolean
    
    bRet = False
    
    If x_OleInvoke(vtb_Cancel) Then
        
        bRet = True
        
    End If

    Cancel = bRet

End Function

Public Function CreateResource(ByVal pResourceAttributes As clsIPortableDeviceValues, ByRef dwOptimalWriteBufferSize As Long, ByRef szCookie As String) As clsIStream

    Dim pszCookie As Long
    Dim ppszCookie As Long
    Dim pdwOptimalWriteBufferSize As Long
    Dim pData As Long
    Dim ppData As Long
    Dim IStream As clsIStream

    ppszCookie = VarPtr(pszCookie)
    pdwOptimalWriteBufferSize = VarPtr(dwOptimalWriteBufferSize)
    
    ppData = VarPtr(pData)

    If x_OleInvoke(vtb_CreateResource, pResourceAttributes.GetInterfacePtr, ppData, pdwOptimalWriteBufferSize, ppszCookie) Then
        
        Set IStream = New clsIStream
        Call IStream.Initialize(pData)

    End If

    szCookie = GetStringFromPointer(pszCookie)
    
    Set CreateResource = IStream


End Function

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    If pInterface = 0 Then

        m_initialized = InitInterface(m_Interface, CLSID_PortableDeviceResources, _
            IID_IPortableDeviceResources)
    
    Else
        
        m_Interface.ifc = pInterface
        m_initialized = True
    
    End If
End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface

End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As Boolean

    Dim ret As Long

    If Not m_initialized Then

        InterfaceError m_Interface, ecd_OleInvoke

    Else

        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)

    End If

End Function

Private Sub x_RaiseError()

    With m_Interface

        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIPortableDeviceResources", .etx

        .ecd = 0
        .etx = ""

    End With

End Sub



