VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsISequentialStream"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const CLSID_SequentialStream As String = ""

Private Const IID_ISequentialStream As String = _
    "{0C733A30-2A1C-11CE-ADE5-00AA0044773D}"

Private Const ERR_BASE As Long = 40670

Private m_initialized As Boolean
Private m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_Read
    vtb_Write
End Enum

Public Function QueryInterface() As Long

    QueryInterface = m_Interface.ifc

End Function

Public Function Read_Stream(ByRef pv() As Byte, ByVal cb As Long) As Long
    
    Dim lRet As Long
    Dim ppv As Long
    Dim cbRead As Long
    Dim pcbRead As Long
    
    ppv = VarPtr(pv(0))
    pcbRead = VarPtr(cbRead)

    If x_OleInvoke(vtb_Read, ppv, cb, pcbRead) Then

        lRet = cbRead

    End If

    Read_Stream = lRet

End Function

Public Function Write_Stream(ByRef pv() As Byte, ByVal cb As Long) As Long

    Dim lRet As Long
    Dim ppv As Long
    Dim cbWritten As Long
    Dim pcbWritten As Long
    
    ppv = VarPtr(pv(0))
    pcbWritten = VarPtr(cbWritten)
    
    If x_OleInvoke(vtb_Write, ppv, cb, pcbWritten) Then

        lRet = cbWritten

    End If

    Write_Stream = lRet

End Function

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    If pInterface = 0 Then

        m_initialized = InitInterface(m_Interface, CLSID_SequentialStream, _
            IID_ISequentialStream)
    
    Else
        
        m_Interface.ifc = pInterface
        m_initialized = True
    
    End If
End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface

End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As Boolean

    Dim ret As Long

    If Not m_initialized Then

        InterfaceError m_Interface, ecd_OleInvoke

    Else

        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)

    End If

End Function

Private Sub x_RaiseError()

    With m_Interface

        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsISequentialStream", .etx

        .ecd = 0
        .etx = ""

    End With

End Sub

