VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIPortableDeviceDataStream"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const CLSID_PortableDeviceDataStream As String = ""

Private Const IID_IPortableDeviceDataStream As String = _
    "{88E04DB3-1012-4D64-9996-F703A950D3F4}"

Private Const ERR_BASE As Long = 40670

Private m_initialized As Boolean
Private m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_Read
    vtb_Write
    vtb_Seek
    vtb_SetSize
    vtb_CopyTo
    vtb_Commit
    vtb_Revert
    vtb_LockRegion
    vtb_UnlockRegion
    vtb_Stat
    vtb_Clone
    vtb_GetObjectID
    vtb_Cancel
End Enum

Public Function GetInterfacePtr() As Long

    GetInterfacePtr = m_Interface.ifc

End Function

Public Function Read_Stream(ByRef pv() As Byte, ByVal cb As Long) As Long
    
    Dim lRet As Long
    Dim ppv As Long
    Dim cbRead As Long
    Dim pcbRead As Long
    
    ppv = VarPtr(pv(0))
    pcbRead = VarPtr(cbRead)

    If x_OleInvoke(vtb_Read, ppv, cb, pcbRead) Then

        lRet = cbRead

    End If

    Read_Stream = lRet

End Function

Public Function Write_Stream(ByRef pv() As Byte, ByVal cb As Long) As Long

    Dim lRet As Long
    Dim ppv As Long
    Dim cbWritten As Long
    Dim pcbWritten As Long
    
    ppv = VarPtr(pv(0))
    pcbWritten = VarPtr(cbWritten)
    
    If x_OleInvoke(vtb_Write, ppv, cb, pcbWritten) Then

        lRet = cbWritten

    End If

    Write_Stream = lRet

End Function

Public Function Seek_Stream(ByVal dlibMove As Currency, ByVal dwOrigin As tagSTREAM_SEEK) As Currency

    Dim cRet As Currency
    Dim libNewPosition As Currency
    Dim plibNewPosition As Long
    
    plibNewPosition = VarPtr(libNewPosition)

    If x_OleInvoke(vtb_Seek, dlibMove, dwOrigin, plibNewPosition) Then

        cRet = libNewPosition
        
    End If

    Seek_Stream = cRet

End Function

Public Function SetSize(ByVal libNewSize As Long) As Boolean

    Dim bRet As Boolean
    
    bRet = False
    
    If x_OleInvoke(vtb_SetSize, libNewSize) Then

        bRet = True

    End If

    SetSize = bRet

End Function

Public Function CopyTo(ByVal pstm As clsIStream, ByVal cb As Currency, ByRef pcbRead As Currency, ByRef pcbWritten As Currency) As Boolean

    Dim bRet As Boolean
    Dim ppcbRead As Long
    Dim ppcbWritten As Long
    
    ppcbRead = VarPtr(pcbRead)
    ppcbWritten = VarPtr(pcbWritten)
    
    bRet = False
    
    If x_OleInvoke(vtb_CopyTo, pstm.GetInterfacePtr, cb, ppcbRead, ppcbWritten) Then

        bRet = True

    End If

    CopyTo = bRet

End Function

Public Function Commit(Optional ByVal grfCommitFlags As STGC = STGC_DEFAULT) As Boolean

    Dim bRet As Boolean
    
    bRet = False
    
    If x_OleInvoke(vtb_Commit, grfCommitFlags) Then

        bRet = True

    End If

    Commit = bRet

End Function

Public Function Revert() As Boolean

    Dim bRet As Boolean
    
    bRet = False
    
    If x_OleInvoke(vtb_Revert) Then

        bRet = True

    End If

    Revert = bRet

End Function

Public Function LockRegion(ByVal libOffset As Currency, ByVal cb As Currency, ByVal dwLockType As LOCKTYPE) As Boolean

    Dim bRet As Boolean
    
    bRet = False
    
    If x_OleInvoke(vtb_LockRegion, libOffset, cb, dwLockType) Then

        bRet = True

    End If

    LockRegion = bRet

End Function

Public Function UnlockRegion(ByVal libOffset As Currency, ByVal cb As Currency, ByVal dwLockType As LOCKTYPE) As Boolean

    Dim bRet As Boolean
    
    bRet = False
    
    If x_OleInvoke(vtb_UnlockRegion, libOffset, cb, dwLockType) Then

        bRet = True

    End If

    UnlockRegion = bRet

End Function

Friend Function Stat(ByRef pstatstg As STATSTG, Optional ByVal grfStatFlag As STATFLAG = STATFLAG_DEFAULT) As Boolean

    Dim bRet As Boolean
    
    bRet = False
    
    If x_OleInvoke(vtb_Stat) Then

        bRet = True

    End If

    Stat = bRet

End Function

Public Function Clone() As clsIStream
        
    If x_OleInvoke(vtb_Clone) Then

    End If

End Function

Public Function Cancel() As Boolean
    
    Dim bRet As Boolean
    
    bRet = False
    
    If x_OleInvoke(vtb_Cancel) Then
        bRet = True
    End If
    
    Cancel = bRet
    
End Function

Public Function GetObjectID() As String
    
    Dim sRet As String
    Dim pszObjectID As String
    Dim ppszObjectID As Long
    
    ppszObjectID = StrPtr(pszObjectID)
    
    If x_OleInvoke(vtb_GetObjectID, ppszObjectID) Then
    
        sRet = GetStringFromPointer(pszObjectID)
        
    End If
    
    GetObjectID = sRet
    
End Function

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    If pInterface = 0 Then

        m_initialized = InitInterface(m_Interface, CLSID_PortableDeviceDataStream, _
            IID_IPortableDeviceDataStream)
    
    Else
        
        m_Interface.ifc = pInterface
        m_initialized = True
    
    End If
End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface

End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As Boolean

    Dim ret As Long

    If Not m_initialized Then

        InterfaceError m_Interface, ecd_OleInvoke

    Else
        
        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)

    End If

End Function

Private Sub x_RaiseError()

    With m_Interface

        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIPortableDeviceDataStream", .etx

        .ecd = 0
        .etx = ""

    End With

End Sub





