Attribute VB_Name = "modBrowseForFolder"
Option Explicit

Private Type BrowseInfo
    lngHwnd        As Long
    pIDLRoot       As Long
    pszDisplayName As Long
    lpszTitle      As Long
    ulFlags        As Long
    lpfnCallback   As Long
    lParam         As Long
    iImage         As Long
End Type

Private Const BIF_RETURNONLYFSDIRS As Long = 1
Private Const MAX_PATH As Long = 260

Private Declare Sub CoTaskMemFree Lib "ole32.dll" ( _
                    ByVal hMem As Long)

Private Declare Function lstrcat Lib "Kernel32" _
                         Alias "lstrcatA" ( _
                         ByVal lpString1 As String, _
                         ByVal lpString2 As String) As Long

Private Declare Function SHBrowseForFolder Lib "shell32" ( _
                         ByRef lpbi As BrowseInfo) As Long

Private Declare Function SHGetPathFromIDList Lib "shell32" ( _
                         ByVal pidList As Long, _
                         ByVal lpBuffer As String) As Long

Public Function BrowseForFolder(ByVal lngHwnd As Long, ByVal strPrompt As String) _
    As String

    On Error GoTo ehBrowseForFolder

    Dim intNull As Integer
    Dim lngIDList As Long, lngResult As Long
    Dim strPath As String
    Dim udtBI As BrowseInfo

    With udtBI

        .lngHwnd = lngHwnd
        .lpszTitle = lstrcat(strPrompt, vbNullString)
        .ulFlags = BIF_RETURNONLYFSDIRS

    End With

    lngIDList = SHBrowseForFolder(udtBI)

    If lngIDList <> 0 Then

        strPath = String(MAX_PATH, 0)

        lngResult = SHGetPathFromIDList(lngIDList, strPath)

        Call CoTaskMemFree(lngIDList)

        intNull = InStr(strPath, vbNullChar)

        If intNull > 0 Then

            strPath = Left(strPath, intNull - 1)

        End If
    End If

    BrowseForFolder = strPath

    Exit Function

ehBrowseForFolder:

    BrowseForFolder = Empty

End Function

