Attribute VB_Name = "modInterface"
Option Explicit

Public Const S_OK               As Long = 0
Public Const CLSCTX_INPROC      As Long = 1

Const CC_STDCALL                As Long = 4
Const IID_Release               As Long = 8

Dim ole_typ(10)                 As Integer
Dim ole_ptr(10)                 As Long
Dim ole_var(10)                 As Variant

Public ole_chrptr               As Long
Public ole_chr                  As String

Public Enum Interface_errCodes
    ecd_none ' no error
    ecd_InvalidCall ' invalid function call
    ecd_OleConvert ' could not convert classid
    ecd_InitInterface ' could not convert interface id
    ecd_OleInvoke ' could not invoke interface function
End Enum

Public Type Interface_Data
    ifc                         As Long
    ecd                         As Interface_errCodes
    etx                         As String
    owner                       As Long
    RaiseErrors                 As Boolean
End Type

Private Declare Function lstrlenW Lib "Kernel32" ( _
                         ByVal lpString As Long) As Long

Private Declare Sub RtlMoveMemory Lib "Kernel32" ( _
                    ByRef hpvDest As Any, _
                    ByRef hpvSource As Any, _
                    ByVal cbCopy As Long)

Public Declare Sub CoTaskMemFree Lib "ole32" ( _
                    ByVal hMem As Long)

Private Declare Function CLSIDFromString Lib "ole32" ( _
                         ByVal lpszProgID As Long, _
                         ByRef pClsid As Any) As Long

Public Declare Function CoCreateInstance Lib "ole32" ( _
                        ByRef rclsid As Any, _
                        ByVal pUnkOuter As Long, _
                        ByVal dwClsContext As Long, _
                        ByRef riid As Any, _
                        ByRef ppv As Long) As Long

Private Declare Sub DispCallFunc Lib "oleaut32" ( _
                    ByVal ppv As Long, _
                    ByVal oVft As Long, _
                    ByVal cc As Long, _
                    ByVal rtTYP As VbVarType, _
                    ByVal paCNT As Long, _
                    ByRef paTypes As Any, _
                    ByRef paValues As Any, _
                    ByRef fuReturn As Variant)

' Interface-Objekt erstellen
Function InitInterface(Interface As Interface_Data, cid As String, IID As String) _
    As Boolean

    Dim car() As Byte
    Dim iar() As Byte

    If Not oleConvert(cid, car()) Then

        InterfaceError Interface, ecd_OleConvert

    ElseIf Not oleConvert(IID, iar()) Then

        InterfaceError Interface, ecd_OleConvert

    ElseIf CoCreateInstance(car(0), 0&, CLSCTX_INPROC, iar(0), Interface.ifc) <> _
        S_OK Then

        InterfaceError Interface, ecd_InitInterface

    Else

        InitInterface = True

    End If

End Function

' Interface-Objekt lschen
Function ReleaseInterface(Interface As Interface_Data)

    Dim ret As Long

    If Interface.ifc Then DispCallFunc Interface.ifc, IID_Release, CC_STDCALL, _
        vbLong, 0, 0, 0, ret

End Function

Public Function InterfaceError(Interface As Interface_Data, Optional ecd As _
    Interface_errCodes = -1) As Boolean

    On Error Resume Next

    Dim dmy As Object
    Dim obj As Object

    With Interface

        If ecd Then .ecd = ecd

        Select Case .ecd

        Case Is < 0:                .etx = "": .ecd = ecd_none
        Case ecd_InvalidCall:       .etx = "invalid function call"
        Case ecd_OleConvert:        .etx = "could not convert classid"
        Case ecd_InitInterface:     .etx = "could not convert interface id"
        Case ecd_OleInvoke:         .etx = "could not invoke ifc function"

        End Select

        If .ecd = ecd_none Then

        ElseIf Not .RaiseErrors Then
        ElseIf .owner Then

            RtlMoveMemory dmy, .owner, 4

            Set obj = dmy

            RtlMoveMemory dmy, 0&, 4
            obj.x_RaiseError

        End If

    End With

End Function

Function oleConvert(cid As String, bar() As Byte) As Boolean

    ReDim bar(15)
    oleConvert = (CLSIDFromString(StrPtr(cid), bar(0)) = S_OK)

End Function

Function oleInvoke(Interface As Interface_Data, cmd As Long, ret As Variant, chk _
    As Boolean, ParamArray arr()) As Long

    Dim lpc As Long
    Dim var

    If Interface.ifc = 0 Then

        InterfaceError Interface, ecd_InvalidCall

    Else

        If UBound(arr) >= 0 Then

            var = arr

            If IsArray(var) Then var = var(0)

            For lpc = 0 To UBound(var)

                ole_typ(lpc) = VarType(var(lpc))
                ole_var(lpc) = var(lpc)
                ole_ptr(lpc) = VarPtr(ole_var(lpc))

            Next

        End If

        DispCallFunc Interface.ifc, cmd * 4, CC_STDCALL, VarType(ret), lpc, _
            ole_typ(0), ole_ptr(0), ret
        
        
        oleInvoke = True

        If Not chk Then

        ElseIf VarType(ret) <> vbLong Then

        ElseIf ret <> S_OK Then

            'Call GetErrMessage(ret)

            InterfaceError Interface, ecd_OleInvoke
            oleInvoke = False

        End If

        If ole_chrptr Then

            lpc = lstrlenW(ole_chrptr)
            ole_chr = Space(lpc)
            RtlMoveMemory ByVal StrPtr(ole_chr), ByVal ole_chrptr, lpc * 2
            CoTaskMemFree ole_chrptr
            ole_chrptr = 0

        End If
    End If

End Function

