﻿' Autor: Frank Schüler
' Datum: 01.01.2018
' Status: Komplett 2

Option Strict On
Option Explicit On

Imports System.Runtime.InteropServices

Public Class PortableDeviceEventCallback
    Implements IDisposable

    Private Const IID_IPortableDeviceEventCallback As String = "A8792A31-F385-493C-A893-40F64EB45F6E"
    Private Const CLSID_PortableDeviceEventCallback As String = ""
    Private Const S_OK As Integer = 0

    Public _ifc As IPortableDeviceEventCallback

#Region "Interface IPortableDeviceEventCallback"
    ' https://msdn.microsoft.com/en-us/library/windows/desktop/dd388545(v=vs.85).aspx
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IPortableDeviceEventCallback)>
    Public Interface IPortableDeviceEventCallback

        Function OnEvent(<[In], MarshalAs(UnmanagedType.Interface)> ByVal pEventParameters As PortableDeviceValues.IPortableDeviceValues) As Integer

    End Interface
#End Region

#Region "Interface Helper"

    ' Called by the SDK to notify the application about asynchronous events.
    Function OnEvent(ByRef pEventParameters As PortableDeviceValues) As Boolean
        Dim ret = _ifc.OnEvent(pEventParameters._ifc)
        If ret = S_OK Then
            Return True
        ElseIf ret < S_OK Then
            Throw New COMException("OnEvent faild", ret)
        End If
        Return False
    End Function

#End Region

#Region "IDisposable Support"
    Private disposedValue As Boolean

    Protected Overridable Sub Dispose(disposing As Boolean)
        If Not disposedValue Then
            If disposing Then
                ' TODO: verwalteten Zustand (verwaltete Objekte) entsorgen.
            End If

            If _ifc IsNot Nothing Then
                Marshal.ReleaseComObject(_ifc)
                _ifc = Nothing
            End If
        End If
        disposedValue = True
    End Sub

    Protected Overrides Sub Finalize()
        Dispose(False)
        MyBase.Finalize()
    End Sub

    Public Sub Dispose() Implements IDisposable.Dispose
        Dispose(True)
        GC.SuppressFinalize(Me)
    End Sub
#End Region


End Class

